%readhb		Read Harwell-Boeing file
%
%usage : A=readhb(file)
%
%file = matrix file name
%A    = returned sparse matrix
%
%Note : This code requires a hb2mlab executable in the same directory
%       as the readhb.m file which converts Harwell-Boeing format
%       to matlab coordinate format. This subroutine will
%       attempt to create a temporary file in the /tmp directory.


%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% These programs were prepared by the Regents of the University of
%% California at Los Alamos National Laboratory (the University) under
%% contract W-7405-ENG-36 with the U.S. Department of Energy (DOE) and
%% under Contract KC-07-01-01 with the Department of Energy(DOE),
%% Office of Science, Mathematical, Information, and Computational Sciences,
%% Applied Mathematical Sciences Program.  All rights in these programs
%% are reserved by the DOE and the University.

%% Permission is granted to the public to copy and use this software
%% without charge, provided that this Notice and the statements of 
%% authorship are reproduced on all copies. Neither the U.S. government 
%% nor the University makes any warranty, express or implied, or assumes 
%% any liability or responsibility for the use of this software.

%% AMG code written by Menno Verbeek, in collaboration with Jane Cullum
%%  and Wayne Joubert.
%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



function A=readhb(file)

tmpfile=['tmp_loadhb_',num2str(floor(rand*10000))];

bindir=strrep(which('readhb'),'readhb.m','');

eval(['!',bindir,'hb2mlab < ',file,' > /tmp/',tmpfile]);
eval(['load /tmp/',tmpfile]);
eval(['A=spconvert(',tmpfile,');']);
delete(['/tmp/',tmpfile]);
